<?xml version='1.0' encoding='UTF-8'?>
<!DOCTYPE widget SYSTEM "quote.dtd"><widget xmlns:f="http://bar.yandex.ru/dev/functional" icon="icons/quote_up.png" name="&wgt.quotes.name;" unique="false" xmlns="http://bar.yandex.ru/dev/gui">
    <f:setting default="0" name="quote-id" scope="instance">
        <control label="&wgt.quotes.settings.id.label;" source="quotelist.xml" template="quotelist.xsl" type="combobox"/>
    </f:setting>
    <f:setting default="15" name="update-interval" scope="widget">
        <control label="&wgt.quotes.settings.interval.label;" label-after="&wgt.quotes.settings.min.label;" max="10000" min="0" spin="5" type="textedit" value-type="int"/>
    </f:setting>
    <f:variable name="update-id" scope="instance"/>
    <f:variable name="throbber-end-time" scope="instance"/>
    <f:data name="quotes-request">
        <f:request>
            <f:param name="url">
                <f:concat>
                    <f:value type="string">http://export.yandex.ru/bar/quotes.xml</f:value>
                    <f:if>
                        <f:equal>
                            <f:value-of name="quote-id"/>
                            <f:value type="number">0</f:value>
                        </f:equal>
                        <f:value type="string"/>
                        <f:concat>
                            <f:value type="string">?id=</f:value>
                            <f:value-of name="quote-id"/>
                        </f:concat>
                    </f:if>
                </f:concat>
            </f:param>
            <f:param name="update">
                <f:mul>
                    <f:value-of name="update-interval"/>
                    <f:value type="number">60</f:value>
                </f:mul>
            </f:param>
            <f:param name="expire">
                <f:value type="number">43200</f:value>
            </f:param>
        </f:request>
    </f:data>
    <f:data name="quotes">
        <f:content>
            <f:value-of name="quotes-request"/>
        </f:content>
    </f:data>
    <f:data name="quotes-count">
        <f:xpath>
            <f:value type="string">count(quotes/quote)</f:value>
            <f:value-of name="quotes"/>
        </f:xpath>
    </f:data>
    <f:data name="quote-list">
        <f:coalesce>
            <f:content>
                <f:request>
                    <f:param name="url">
                        <f:value type="string">http://export.yandex.ru/bar/quotelist.xml?ver=2</f:value>
                    </f:param>
                    <f:param name="update">
                        <f:value type="number">2592000</f:value>
                    </f:param>
                    <f:param name="expire">
                        <f:value type="number">946080000</f:value>
                    </f:param>
                </f:request>
            </f:content>
            <f:file>
                <f:param name="type">
                    <f:value type="string">xml</f:value>
                </f:param>
                <f:param name="path">
                    <f:value type="string">quotelist.xml</f:value>
                </f:param>
            </f:file>
        </f:coalesce>
    </f:data>
    <f:data name="value1">
        <f:xpath>
            <f:value type="string">number(quotes/quote[1]/value)</f:value>
            <f:value-of name="quotes"/>
        </f:xpath>
    </f:data>
    <f:data name="has-data1">
        <f:try>
            <f:not-equal>
                <f:value-of name="value1"/>
                <f:value type="string"/>
            </f:not-equal>
            <f:param name="...">
                <f:value type="bool">false</f:value>
            </f:param>
        </f:try>
    </f:data>
    <f:data name="id1">
        <f:xpath>
            <f:value type="string">number(quotes/quote[1]/@id)</f:value>
            <f:value-of name="quotes"/>
        </f:xpath>
    </f:data>
    <f:data name="precision1">
        <f:xpath>
            <f:concat>
                <f:value type="string">number(//quote[@id='</f:value>
                <f:value-of name="id1"/>
                <f:value type="string">']/precision)</f:value>
            </f:concat>
            <f:value-of name="quote-list"/>
        </f:xpath>
    </f:data>
    <f:data name="change1">
        <f:xpath>
            <f:value type="string">number(quotes/quote[1]/change)</f:value>
            <f:value-of name="quotes"/>
        </f:xpath>
    </f:data>
    <f:data name="buy1">
        <f:try>
            <f:xpath>
                <f:value type="string">number(quotes/quote[1]/buy/value)</f:value>
                <f:value-of name="quotes"/>
            </f:xpath>
            <f:param name="...">
                <f:value type="empty"/>
            </f:param>
        </f:try>
    </f:data>
    <f:data name="buy-change1">
        <f:try>
            <f:xpath>
                <f:value type="string">number(quotes/quote[1]/buy/change)</f:value>
                <f:value-of name="quotes"/>
            </f:xpath>
            <f:param name="...">
                <f:value type="empty"/>
            </f:param>
        </f:try>
    </f:data>
    <f:data name="tomorrow-node1">
        <f:xpath>
            <f:value type="string">quotes/quote[1]/tomorrow</f:value>
            <f:value-of name="quotes"/>
        </f:xpath>
    </f:data>
    <f:data name="tomorrow1">
        <f:try>
            <f:xpath>
                <f:value type="string">number(quotes/quote[1]/tomorrow)</f:value>
                <f:value-of name="quotes"/>
            </f:xpath>
            <f:param name="...">
                <f:value type="empty"/>
            </f:param>
        </f:try>
    </f:data>
    <f:data name="tomorrow-change1">
        <f:try>
            <f:xpath>
                <f:value type="string">number(quotes/quote[1]/tomorrowchange)</f:value>
                <f:value-of name="quotes"/>
            </f:xpath>
            <f:param name="...">
                <f:value type="empty"/>
            </f:param>
        </f:try>
    </f:data>
    <f:data name="tomorrow-buy1">
        <f:try>
            <f:xpath>
                <f:value type="string">number(quotes/quote[1]/tomorrowbuy/tomorrow)</f:value>
                <f:value-of name="quotes"/>
            </f:xpath>
            <f:param name="...">
                <f:value type="empty"/>
            </f:param>
        </f:try>
    </f:data>
    <f:data name="tomorrow-buy-change1">
        <f:try>
            <f:xpath>
                <f:value type="string">number(quotes/quote[1]/tomorrowbuy/tomorrowchange)</f:value>
                <f:value-of name="quotes"/>
            </f:xpath>
            <f:param name="...">
                <f:value type="empty"/>
            </f:param>
        </f:try>
    </f:data>
    <f:data name="displ-value1">
        <f:coalesce>
            <f:value-of name="tomorrow1"/>
            <f:value-of name="value1"/>
        </f:coalesce>
    </f:data>
    <f:data name="displ-buy1">
        <f:coalesce>
            <f:value-of name="tomorrow-buy1"/>
            <f:value-of name="buy1"/>
        </f:coalesce>
    </f:data>
    <f:data name="icon-prefix1">
        <f:coalesce>
            <f:xpath>
                <f:concat>
                    <f:value type="string">string(//quote[@id='</f:value>
                    <f:value-of name="id1"/>
                    <f:value type="string">']/@icon)</f:value>
                </f:concat>
                <f:value-of name="quote-list"/>
            </f:xpath>
            <f:xpath>
                <f:concat>
                    <f:value type="string">string(//quote[@id='</f:value>
                    <f:value-of name="id1"/>
                    <f:value type="string">']/../@icon)</f:value>
                </f:concat>
                <f:value-of name="quote-list"/>
            </f:xpath>
            <f:value type="string">quote</f:value>
        </f:coalesce>
    </f:data>
    <f:data name="icon-suffix1">
        <f:if>
            <f:lt>
                <f:coalesce>
                    <f:value-of name="tomorrow-change1"/>
                    <f:value-of name="change1"/>
                </f:coalesce>
                <f:value type="number">0</f:value>
            </f:lt>
            <f:value type="string">_down.png</f:value>
            <f:value type="string">_up.png</f:value>
        </f:if>
    </f:data>
    <f:data name="value2">
        <f:if>
            <f:gt>
                <f:value-of name="quotes-count"/>
                <f:value type="number">1</f:value>
            </f:gt>
            <f:xpath>
                <f:value type="string">number(quotes/quote[2]/value)</f:value>
                <f:value-of name="quotes"/>
            </f:xpath>
            <f:value type="empty"/>
        </f:if>
    </f:data>
    <f:data name="has-data2">
        <f:try>
            <f:not-equal>
                <f:value-of name="value2"/>
                <f:value type="string"/>
            </f:not-equal>
            <f:param name="...">
                <f:value type="bool">false</f:value>
            </f:param>
        </f:try>
    </f:data>
    <f:data name="id2">
        <f:xpath>
            <f:value type="string">number(quotes/quote[2]/@id)</f:value>
            <f:value-of name="quotes"/>
        </f:xpath>
    </f:data>
    <f:data name="precision2">
        <f:xpath>
            <f:concat>
                <f:value type="string">number(//quote[@id='</f:value>
                <f:value-of name="id2"/>
                <f:value type="string">']/precision)</f:value>
            </f:concat>
            <f:value-of name="quote-list"/>
        </f:xpath>
    </f:data>
    <f:data name="change2">
        <f:xpath>
            <f:value type="string">number(quotes/quote[2]/change)</f:value>
            <f:value-of name="quotes"/>
        </f:xpath>
    </f:data>
    <f:data name="buy2">
        <f:try>
            <f:xpath>
                <f:value type="string">number(quotes/quote[2]/buy/value)</f:value>
                <f:value-of name="quotes"/>
            </f:xpath>
            <f:param name="...">
                <f:value type="empty"/>
            </f:param>
        </f:try>
    </f:data>
    <f:data name="buy-change2">
        <f:try>
            <f:xpath>
                <f:value type="string">number(quotes/quote[2]/buy/change)</f:value>
                <f:value-of name="quotes"/>
            </f:xpath>
            <f:param name="...">
                <f:value type="empty"/>
            </f:param>
        </f:try>
    </f:data>
    <f:data name="tomorrow-node2">
        <f:xpath>
            <f:value type="string">quotes/quote[2]/tomorrow</f:value>
            <f:value-of name="quotes"/>
        </f:xpath>
    </f:data>
    <f:data name="tomorrow2">
        <f:try>
            <f:xpath>
                <f:value type="string">number(quotes/quote[2]/tomorrow)</f:value>
                <f:value-of name="quotes"/>
            </f:xpath>
            <f:param name="...">
                <f:value type="empty"/>
            </f:param>
        </f:try>
    </f:data>
    <f:data name="tomorrow-change2">
        <f:try>
            <f:xpath>
                <f:value type="string">number(quotes/quote[2]/tomorrowchange)</f:value>
                <f:value-of name="quotes"/>
            </f:xpath>
            <f:param name="...">
                <f:value type="empty"/>
            </f:param>
        </f:try>
    </f:data>
    <f:data name="tomorrow-buy2">
        <f:try>
            <f:xpath>
                <f:value type="string">number(quotes/quote[2]/tomorrowbuy/tomorrow)</f:value>
                <f:value-of name="quotes"/>
            </f:xpath>
            <f:param name="...">
                <f:value type="empty"/>
            </f:param>
        </f:try>
    </f:data>
    <f:data name="tomorrow-buy-change2">
        <f:try>
            <f:xpath>
                <f:value type="string">number(quotes/quote[2]/tomorrowbuy/tomorrowchange)</f:value>
                <f:value-of name="quotes"/>
            </f:xpath>
            <f:param name="...">
                <f:value type="empty"/>
            </f:param>
        </f:try>
    </f:data>
    <f:data name="displ-value2">
        <f:coalesce>
            <f:value-of name="tomorrow2"/>
            <f:value-of name="value2"/>
        </f:coalesce>
    </f:data>
    <f:data name="displ-buy2">
        <f:coalesce>
            <f:value-of name="tomorrow-buy2"/>
            <f:value-of name="buy2"/>
        </f:coalesce>
    </f:data>
    <f:data name="icon-prefix2">
        <f:coalesce>
            <f:xpath>
                <f:concat>
                    <f:value type="string">string(//quote[@id='</f:value>
                    <f:value-of name="id2"/>
                    <f:value type="string">']/@icon)</f:value>
                </f:concat>
                <f:value-of name="quote-list"/>
            </f:xpath>
            <f:xpath>
                <f:concat>
                    <f:value type="string">string(//quote[@id='</f:value>
                    <f:value-of name="id2"/>
                    <f:value type="string">']/../@icon)</f:value>
                </f:concat>
                <f:value-of name="quote-list"/>
            </f:xpath>
            <f:value type="string">quote</f:value>
        </f:coalesce>
    </f:data>
    <f:data name="icon-suffix2">
        <f:if>
            <f:lt>
                <f:coalesce>
                    <f:value-of name="tomorrow-change2"/>
                    <f:value-of name="change2"/>
                </f:coalesce>
                <f:value type="number">0</f:value>
            </f:lt>
            <f:value type="string">_down.png</f:value>
            <f:value type="string">_up.png</f:value>
        </f:if>
    </f:data>
    <f:data name="value3">
        <f:if>
            <f:gt>
                <f:value-of name="quotes-count"/>
                <f:value type="number">2</f:value>
            </f:gt>
            <f:xpath>
                <f:value type="string">number(quotes/quote[3]/value)</f:value>
                <f:value-of name="quotes"/>
            </f:xpath>
            <f:value type="empty"/>
        </f:if>
    </f:data>
    <f:data name="has-data3">
        <f:try>
            <f:not-equal>
                <f:value-of name="value3"/>
                <f:value type="string"/>
            </f:not-equal>
            <f:param name="...">
                <f:value type="bool">false</f:value>
            </f:param>
        </f:try>
    </f:data>
    <f:data name="id3">
        <f:xpath>
            <f:value type="string">number(quotes/quote[3]/@id)</f:value>
            <f:value-of name="quotes"/>
        </f:xpath>
    </f:data>
    <f:data name="precision3">
        <f:xpath>
            <f:concat>
                <f:value type="string">number(//quote[@id='</f:value>
                <f:value-of name="id3"/>
                <f:value type="string">']/precision)</f:value>
            </f:concat>
            <f:value-of name="quote-list"/>
        </f:xpath>
    </f:data>
    <f:data name="change3">
        <f:xpath>
            <f:value type="string">number(quotes/quote[3]/change)</f:value>
            <f:value-of name="quotes"/>
        </f:xpath>
    </f:data>
    <f:data name="buy3">
        <f:try>
            <f:xpath>
                <f:value type="string">number(quotes/quote[3]/buy/value)</f:value>
                <f:value-of name="quotes"/>
            </f:xpath>
            <f:param name="...">
                <f:value type="empty"/>
            </f:param>
        </f:try>
    </f:data>
    <f:data name="buy-change3">
        <f:try>
            <f:xpath>
                <f:value type="string">number(quotes/quote[3]/buy/change)</f:value>
                <f:value-of name="quotes"/>
            </f:xpath>
            <f:param name="...">
                <f:value type="empty"/>
            </f:param>
        </f:try>
    </f:data>
    <f:data name="tomorrow-node3">
        <f:xpath>
            <f:value type="string">quotes/quote[3]/tomorrow</f:value>
            <f:value-of name="quotes"/>
        </f:xpath>
    </f:data>
    <f:data name="tomorrow3">
        <f:try>
            <f:xpath>
                <f:value type="string">number(quotes/quote[3]/tomorrow)</f:value>
                <f:value-of name="quotes"/>
            </f:xpath>
            <f:param name="...">
                <f:value type="empty"/>
            </f:param>
        </f:try>
    </f:data>
    <f:data name="tomorrow-change3">
        <f:try>
            <f:xpath>
                <f:value type="string">number(quotes/quote[3]/tomorrowchange)</f:value>
                <f:value-of name="quotes"/>
            </f:xpath>
            <f:param name="...">
                <f:value type="empty"/>
            </f:param>
        </f:try>
    </f:data>
    <f:data name="tomorrow-buy3">
        <f:try>
            <f:xpath>
                <f:value type="string">number(quotes/quote[3]/tomorrowbuy/tomorrow)</f:value>
                <f:value-of name="quotes"/>
            </f:xpath>
            <f:param name="...">
                <f:value type="empty"/>
            </f:param>
        </f:try>
    </f:data>
    <f:data name="tomorrow-buy-change3">
        <f:try>
            <f:xpath>
                <f:value type="string">number(quotes/quote[3]/tomorrowbuy/tomorrowchange)</f:value>
                <f:value-of name="quotes"/>
            </f:xpath>
            <f:param name="...">
                <f:value type="empty"/>
            </f:param>
        </f:try>
    </f:data>
    <f:data name="displ-value3">
        <f:coalesce>
            <f:value-of name="tomorrow3"/>
            <f:value-of name="value3"/>
        </f:coalesce>
    </f:data>
    <f:data name="displ-buy3">
        <f:coalesce>
            <f:value-of name="tomorrow-buy3"/>
            <f:value-of name="buy3"/>
        </f:coalesce>
    </f:data>
    <f:data name="icon-prefix3">
        <f:coalesce>
            <f:xpath>
                <f:concat>
                    <f:value type="string">string(//quote[@id='</f:value>
                    <f:value-of name="id3"/>
                    <f:value type="string">']/@icon)</f:value>
                </f:concat>
                <f:value-of name="quote-list"/>
            </f:xpath>
            <f:xpath>
                <f:concat>
                    <f:value type="string">string(//quote[@id='</f:value>
                    <f:value-of name="id3"/>
                    <f:value type="string">']/../@icon)</f:value>
                </f:concat>
                <f:value-of name="quote-list"/>
            </f:xpath>
            <f:value type="string">quote</f:value>
        </f:coalesce>
    </f:data>
    <f:data name="icon-suffix3">
        <f:if>
            <f:lt>
                <f:coalesce>
                    <f:value-of name="tomorrow-change3"/>
                    <f:value-of name="change3"/>
                </f:coalesce>
                <f:value type="number">0</f:value>
            </f:lt>
            <f:value type="string">_down.png</f:value>
            <f:value type="string">_up.png</f:value>
        </f:if>
    </f:data>
    <button>
        <icon>
            <f:if>
                <f:value-of name="has-data1"/>
                <f:if>
                    <f:not>
                        <f:or>
                            <f:is-empty>
                                <f:value-of name="update-id"/>
                            </f:is-empty>
                            <f:and>
                                <f:finished>
                                    <f:value-of name="update-id"/>
                                </f:finished>
                                <f:time-arrived>
                                    <f:value-of name="throbber-end-time"/>
                                </f:time-arrived>
                            </f:and>
                        </f:or>
                    </f:not>
                    <f:value type="string">xb://toolkit/images/throbber.gif</f:value>
                    <f:concat>
                        <f:value type="string">icons/</f:value>
                        <f:value-of name="icon-prefix1"/>
                        <f:value-of name="icon-suffix1"/>
                    </f:concat>
                </f:if>
                <f:value type="string">icons/quote_up.png</f:value>
            </f:if>
        </icon>
        
        <text>            
            <f:if>               
                <f:value-of name="has-data1"/>
                <f:xpath>
                    <f:concat>
                        <f:value type="string">string(//quote[@id='</f:value>
                        <f:value-of name="id1"/>
                        <f:value type="string">']/shortname)</f:value>
                    </f:concat>
                    <f:value-of name="quote-list"/>
                </f:xpath>
                <f:value type="string">&wgt.quotes.name;</f:value>
            </f:if>
            <f:optional>
                <f:value-of name="has-data1"/>
                    <style>
                    <f:concat>
                        <f:value type="string"> </f:value>
                        <f:if>
                            <f:value-of name="displ-buy1"/>
                            <f:concat>
                                <f:format-number>
                                    <f:value-of name="displ-buy1"/>
                                    <f:param name="precision">
                                        <f:value type="number">2</f:value>
                                    </f:param>
                                    <f:param name="separate-groups">
                                        <f:value type="bool">false</f:value>
                                    </f:param>
                                </f:format-number>
                                <f:value type="string">&#160;—&#160;</f:value>
                            </f:concat>
                            <f:value type="string"/>
                        </f:if>
                        <f:format-number>
                            <f:value-of name="displ-value1"/>
                            <f:param name="precision">
                                <f:value type="number">2</f:value>
                            </f:param>
                            <f:param name="separate-groups">
                                <f:value type="bool">false</f:value>
                            </f:param>
                        </f:format-number>
                    </f:concat>
                </style>
            </f:optional>
        </text>
    
        <tooltip>
            <f:optional>
                <f:value-of name="has-data1"/>
                <grid>
                    <row>
                        <cell h-align="center">
                            <style font-weight="bold">
                                <f:xpath>
                                    <f:concat>
                                        <f:value type="string">string(//quote[@id='</f:value>
                                        <f:value-of name="id1"/>
                                        <f:value type="string">']/name)</f:value>
                                    </f:concat>
                                    <f:value-of name="quote-list"/>
                                </f:xpath>
                            </style>
                        </cell>
                        <cell merge-left="true"/>
                    </row>
                    <row>
                        <cell h-align="right">&wgt.quotes.tooltip.today;:</cell>
                        <cell>
                            <f:concat>
                                <f:if>
                                    <f:value-of name="buy1"/>
                                    <f:concat>
                                        <f:format-number>
                                            <f:value-of name="buy1"/>
                                            <f:param name="precision">
                                                <f:value-of name="precision1"/>
                                            </f:param>
                                        </f:format-number>
                                        <f:value type="string"> (</f:value>
                                        <f:format-number>
                                            <f:value-of name="buy-change1"/>
                                            <f:param name="precision">
                                                <f:value-of name="precision1"/>
                                            </f:param>
                                            <f:param name="positive-sign">
                                                <f:value type="bool">true</f:value>
                                            </f:param>
                                        </f:format-number>
                                        <f:value type="string">)&#160;—&#160;</f:value>
                                    </f:concat>
                                    <f:value type="string"/>
                                </f:if>
                                <f:format-number>
                                    <f:value-of name="value1"/>
                                    <f:param name="precision">
                                        <f:value-of name="precision1"/>
                                    </f:param>
                                </f:format-number>
                                <f:value type="string"> (</f:value>
                                <f:format-number>
                                    <f:value-of name="change1"/>
                                    <f:param name="precision">
                                        <f:value-of name="precision1"/>
                                    </f:param>
                                    <f:param name="positive-sign">
                                        <f:value type="bool">true</f:value>
                                    </f:param>
                                </f:format-number>
                                <f:value type="string">)</f:value>
                            </f:concat>
                        </cell>
                    </row>
                    <f:optional>
                        <f:value-of name="tomorrow-node1"/>
                        <row>
                            <cell h-align="right">&wgt.quotes.tooltip.tomorrow;:</cell>
                            <cell>
                                <f:concat>
                                    <f:if>
                                        <f:value-of name="tomorrow-buy1"/>
                                        <f:concat>
                                            <f:format-number>
                                                <f:value-of name="tomorrow-buy1"/>
                                                <f:param name="precision">
                                                    <f:value-of name="precision1"/>
                                                </f:param>
                                            </f:format-number>
                                            <f:value type="string"> (</f:value>
                                            <f:format-number>
                                                <f:value-of name="tomorrow-buy-change1"/>
                                                <f:param name="precision">
                                                    <f:value-of name="precision1"/>
                                                </f:param>
                                                <f:param name="positive-sign">
                                                    <f:value type="bool">true</f:value>
                                                </f:param>
                                            </f:format-number>
                                            <f:value type="string">)&#160;—&#160;</f:value>
                                        </f:concat>
                                        <f:value type="string"/>
                                    </f:if>
                                    <f:format-number>
                                        <f:value-of name="tomorrow1"/>
                                        <f:param name="precision">
                                            <f:value-of name="precision1"/>
                                        </f:param>
                                    </f:format-number>
                                    <f:value type="string"> (</f:value>
                                    <f:format-number>
                                        <f:value-of name="tomorrow-change1"/>
                                        <f:param name="precision">
                                            <f:value-of name="precision1"/>
                                        </f:param>
                                        <f:param name="positive-sign">
                                            <f:value type="bool">true</f:value>
                                        </f:param>
                                    </f:format-number>
                                    <f:value type="string">)</f:value>
                                </f:concat>
                            </cell>
                        </row>
                    </f:optional>
                </grid>
            </f:optional>
            <f:optional>
                <f:not>
                    <f:value-of name="has-data1"/>
                </f:not>
                <style>&wgt.quotes.nodata;</style>
            </f:optional>
        </tooltip>
        <action>
            <f:navigate action="2120">
                <f:xpath>
                    <f:concat>
                        <f:value type="string">string(//quote[@id='</f:value>
                        <f:value-of name="id1"/>
                        <f:value type="string">']/url)</f:value>
                    </f:concat>
                    <f:value-of name="quote-list"/>
                </f:xpath>
            </f:navigate>
        </action>
        <f:optional>
            <f:not>
                <f:or>
                    <f:value-of name="has-data2"/>
                    <f:value-of name="has-data3"/>
                </f:or>
            </f:not>
            <menu>
                <menuitem>
                    <text>&wgt.quotes.refresh;</text>
                    <action>
                        <f:assign name="update-id">
                            <f:update>
                                <f:value-of name="quotes-request"/>
                            </f:update>
                        </f:assign>
                        <f:assign name="throbber-end-time">
                            <f:add>
                                <f:timestamp/>
                                <f:value type="number">1.5</f:value>
                            </f:add>
                        </f:assign>
                    </action>
                </menuitem>
                <separator/>
                <menuitem>
                    <text>&wgt.quotes.copy;</text>
                    <action>
                        <f:copy-to-clipboard>
                            <f:format-number>
                                <f:if>
                                    <f:value-of name="displ-buy1"/>
                                    <f:value-of name="displ-buy1"/>
                                    <f:value-of name="displ-value1"/>
                                </f:if>
                                <f:param name="separate-groups">
                                    <f:value type="bool">false</f:value>
                                </f:param>
                            </f:format-number>
                        </f:copy-to-clipboard>
                    </action>
                </menuitem>
                <separator/>
                <menuitem>
                    <text>&wgt.quotes.change;</text>
                    <action>
                        <f:setup-widget/>
                    </action>
                </menuitem>
                <menuitem>
                    <text>&wgt.quotes.delete;</text>
                    <action>
                        <f:remove-widget/>
                    </action>
                </menuitem>
                <menuitem>
                    <text>&wgt.quotes.add;</text>
                    <action>
                        <f:add-widget/>
                    </action>
                </menuitem>
            </menu>
        </f:optional>
    </button>
    <f:optional>
        <f:value-of name="has-data2"/>
        <button>
            <icon>
                <f:if>
                    <f:not>
                        <f:or>
                            <f:is-empty>
                                <f:value-of name="update-id"/>
                            </f:is-empty>
                            <f:and>
                                <f:finished>
                                    <f:value-of name="update-id"/>
                                </f:finished>
                                <f:time-arrived>
                                    <f:value-of name="throbber-end-time"/>
                                </f:time-arrived>
                            </f:and>
                        </f:or>
                    </f:not>
                    <f:value type="string">xb://toolkit/images/throbber.gif</f:value>
                    <f:concat>
                        <f:value type="string">icons/</f:value>
                        <f:value-of name="icon-prefix2"/>
                        <f:value-of name="icon-suffix2"/>
                    </f:concat>
                </f:if>
            </icon>
            <text>
                <f:xpath>
                    <f:concat>
                        <f:value type="string">string(//quote[@id='</f:value>
                        <f:value-of name="id2"/>
                        <f:value type="string">']/shortname)</f:value>
                    </f:concat>
                    <f:value-of name="quote-list"/>
                </f:xpath>
                <style font-weight="bold">
                    <f:concat>
                        <f:value type="string"> </f:value>
                        <f:if>
                            <f:value-of name="displ-buy2"/>
                            <f:concat>
                                <f:format-number>
                                    <f:value-of name="displ-buy2"/>
                                    <f:param name="precision">
                                        <f:value type="number">2</f:value>
                                    </f:param>
                                    <f:param name="separate-groups">
                                        <f:value type="bool">false</f:value>
                                    </f:param>
                                </f:format-number>
                                <f:value type="string">&#160;—&#160;</f:value>
                            </f:concat>
                            <f:value type="string"/>
                        </f:if>
                        <f:format-number>
                            <f:value-of name="displ-value2"/>
                            <f:param name="precision">
                                <f:value type="number">2</f:value>
                            </f:param>
                            <f:param name="separate-groups">
                                <f:value type="bool">false</f:value>
                            </f:param>
                        </f:format-number>
                    </f:concat>
                </style>
            </text>
            <tooltip>
                <grid>
                    <row>
                        <cell h-align="center">
                            <style font-weight="bold">
                                <f:xpath>
                                    <f:concat>
                                        <f:value type="string">string(//quote[@id='</f:value>
                                        <f:value-of name="id2"/>
                                        <f:value type="string">']/name)</f:value>
                                    </f:concat>
                                    <f:value-of name="quote-list"/>
                                </f:xpath>
                            </style>
                        </cell>
                        <cell merge-left="true"/>
                    </row>
                    <row>
                        <cell h-align="right">&wgt.quotes.tooltip.today;:</cell>
                        <cell>
                            <f:concat>
                                <f:if>
                                    <f:value-of name="buy2"/>
                                    <f:concat>
                                        <f:format-number>
                                            <f:value-of name="buy2"/>
                                            <f:param name="precision">
                                                <f:value-of name="precision2"/>
                                            </f:param>
                                        </f:format-number>
                                        <f:value type="string"> (</f:value>
                                        <f:format-number>
                                            <f:value-of name="buy-change2"/>
                                            <f:param name="precision">
                                                <f:value-of name="precision2"/>
                                            </f:param>
                                            <f:param name="positive-sign">
                                                <f:value type="bool">true</f:value>
                                            </f:param>
                                        </f:format-number>
                                        <f:value type="string">)&#160;—&#160;</f:value>
                                    </f:concat>
                                    <f:value type="string"/>
                                </f:if>
                                <f:format-number>
                                    <f:value-of name="value2"/>
                                    <f:param name="precision">
                                        <f:value-of name="precision2"/>
                                    </f:param>
                                </f:format-number>
                                <f:value type="string"> (</f:value>
                                <f:format-number>
                                    <f:value-of name="change2"/>
                                    <f:param name="precision">
                                        <f:value-of name="precision2"/>
                                    </f:param>
                                    <f:param name="positive-sign">
                                        <f:value type="bool">true</f:value>
                                    </f:param>
                                </f:format-number>
                                <f:value type="string">)</f:value>
                            </f:concat>
                        </cell>
                    </row>
                    <f:optional>
                        <f:value-of name="tomorrow-node2"/>
                        <row>
                            <cell h-align="right">&wgt.quotes.tooltip.tomorrow;:</cell>
                            <cell>
                                <f:concat>
                                    <f:if>
                                        <f:value-of name="tomorrow-buy2"/>
                                        <f:concat>
                                            <f:format-number>
                                                <f:value-of name="tomorrow-buy2"/>
                                                <f:param name="precision">
                                                    <f:value-of name="precision2"/>
                                                </f:param>
                                            </f:format-number>
                                            <f:value type="string"> (</f:value>
                                            <f:format-number>
                                                <f:value-of name="tomorrow-buy-change2"/>
                                                <f:param name="precision">
                                                    <f:value-of name="precision2"/>
                                                </f:param>
                                                <f:param name="positive-sign">
                                                    <f:value type="bool">true</f:value>
                                                </f:param>
                                            </f:format-number>
                                            <f:value type="string">)&#160;—&#160;</f:value>
                                        </f:concat>
                                        <f:value type="string"/>
                                    </f:if>
                                    <f:format-number>
                                        <f:value-of name="tomorrow2"/>
                                        <f:param name="precision">
                                            <f:value-of name="precision2"/>
                                        </f:param>
                                    </f:format-number>
                                    <f:value type="string"> (</f:value>
                                    <f:format-number>
                                        <f:value-of name="tomorrow-change2"/>
                                        <f:param name="precision">
                                            <f:value-of name="precision2"/>
                                        </f:param>
                                        <f:param name="positive-sign">
                                            <f:value type="bool">true</f:value>
                                        </f:param>
                                    </f:format-number>
                                    <f:value type="string">)</f:value>
                                </f:concat>
                            </cell>
                        </row>
                    </f:optional>
                </grid>
            </tooltip>
            <action>
                <f:navigate action="2120">
                    <f:xpath>
                        <f:concat>
                            <f:value type="string">string(//quote[@id='</f:value>
                            <f:value-of name="id2"/>
                            <f:value type="string">']/url)</f:value>
                        </f:concat>
                        <f:value-of name="quote-list"/>
                    </f:xpath>
                </f:navigate>
            </action>
            <f:optional>
                <f:not>
                    <f:value-of name="has-data3"/>
                </f:not>
                <menu>
                    <menuitem>
                        <text>&wgt.quotes.refresh;</text>
                        <action>
                            <f:assign name="update-id">
                                <f:update>
                                    <f:value-of name="quotes-request"/>
                                </f:update>
                            </f:assign>
                            <f:assign name="throbber-end-time">
                                <f:add>
                                    <f:timestamp/>
                                    <f:value type="number">1.5</f:value>
                                </f:add>
                            </f:assign>
                        </action>
                    </menuitem>
                    <separator/>
                    <f:optional>
                        <f:value-of name="has-data1"/>
                        <menuitem>
                            <text>
                                <f:concat>
                                    <f:value type="string">&wgt.quotes.copy;&#160;</f:value>
                                    <f:xpath>
                                        <f:concat>
                                            <f:value type="string">string(//quote[@id='</f:value>
                                            <f:value-of name="id1"/>
                                            <f:value type="string">']/name)</f:value>
                                        </f:concat>
                                        <f:value-of name="quote-list"/>
                                    </f:xpath>
                                </f:concat>
                            </text>
                            <action>
                                <f:copy-to-clipboard>
                                    <f:format-number>
                                        <f:if>
                                            <f:value-of name="displ-buy1"/>
                                            <f:value-of name="displ-buy1"/>
                                            <f:value-of name="displ-value1"/>
                                        </f:if>
                                        <f:param name="separate-groups">
                                            <f:value type="bool">false</f:value>
                                        </f:param>
                                    </f:format-number>
                                </f:copy-to-clipboard>
                            </action>
                        </menuitem>
                    </f:optional>
                    <menuitem>
                        <text>
                            <f:concat>
                                <f:value type="string">&wgt.quotes.copy;&#160;</f:value>
                                <f:xpath>
                                    <f:concat>
                                        <f:value type="string">string(//quote[@id='</f:value>
                                        <f:value-of name="id2"/>
                                        <f:value type="string">']/name)</f:value>
                                    </f:concat>
                                    <f:value-of name="quote-list"/>
                                </f:xpath>
                            </f:concat>
                        </text>
                        <action>
                            <f:copy-to-clipboard>
                                <f:format-number>
                                    <f:if>
                                        <f:value-of name="displ-buy2"/>
                                        <f:value-of name="displ-buy2"/>
                                        <f:value-of name="displ-value2"/>
                                    </f:if>
                                    <f:param name="separate-groups">
                                        <f:value type="bool">false</f:value>
                                    </f:param>
                                </f:format-number>
                            </f:copy-to-clipboard>
                        </action>
                    </menuitem>
                    <separator/>
                    <menuitem>
                        <text>&wgt.quotes.change;</text>
                        <action>
                            <f:setup-widget/>
                        </action>
                    </menuitem>
                    <menuitem>
                        <text>&wgt.quotes.delete;</text>
                        <action>
                            <f:remove-widget/>
                        </action>
                    </menuitem>
                    <menuitem>
                        <text>&wgt.quotes.add;</text>
                        <action>
                            <f:add-widget/>
                        </action>
                    </menuitem>
                </menu>
            </f:optional>
        </button>
    </f:optional>
    <f:optional>
        <f:value-of name="has-data3"/>
        <button>
            <icon>
                <f:if>
                    <f:not>
                        <f:or>
                            <f:is-empty>
                                <f:value-of name="update-id"/>
                            </f:is-empty>
                            <f:and>
                                <f:finished>
                                    <f:value-of name="update-id"/>
                                </f:finished>
                                <f:time-arrived>
                                    <f:value-of name="throbber-end-time"/>
                                </f:time-arrived>
                            </f:and>
                        </f:or>
                    </f:not>
                    <f:value type="string">xb://toolkit/images/throbber.gif</f:value>
                    <f:concat>
                        <f:value type="string">icons/</f:value>
                        <f:value-of name="icon-prefix3"/>
                        <f:value-of name="icon-suffix3"/>
                    </f:concat>
                </f:if>
            </icon>
            <text>
                <f:xpath>
                    <f:concat>
                        <f:value type="string">string(//quote[@id='</f:value>
                        <f:value-of name="id3"/>
                        <f:value type="string">']/shortname)</f:value>
                    </f:concat>
                    <f:value-of name="quote-list"/>
                </f:xpath>
                <style font-weight="bold">
                    <f:concat>
                        <f:value type="string"> </f:value>
                        <f:if>
                            <f:value-of name="displ-buy3"/>
                            <f:concat>
                                <f:format-number>
                                    <f:value-of name="displ-buy3"/>
                                    <f:param name="precision">
                                        <f:value type="number">2</f:value>
                                    </f:param>
                                    <f:param name="separate-groups">
                                        <f:value type="bool">false</f:value>
                                    </f:param>
                                </f:format-number>
                                <f:value type="string">&#160;—&#160;</f:value>
                            </f:concat>
                            <f:value type="string"/>
                        </f:if>
                        <f:format-number>
                            <f:value-of name="displ-value3"/>
                            <f:param name="precision">
                                <f:value type="number">2</f:value>
                            </f:param>
                            <f:param name="separate-groups">
                                <f:value type="bool">false</f:value>
                            </f:param>
                        </f:format-number>
                    </f:concat>
                </style>
            </text>
            <tooltip>
                <grid>
                    <row>
                        <cell h-align="center">
                            <style font-weight="bold">
                                <f:xpath>
                                    <f:concat>
                                        <f:value type="string">string(//quote[@id='</f:value>
                                        <f:value-of name="id3"/>
                                        <f:value type="string">']/name)</f:value>
                                    </f:concat>
                                    <f:value-of name="quote-list"/>
                                </f:xpath>
                            </style>
                        </cell>
                        <cell merge-left="true"/>
                    </row>
                    <row>
                        <cell h-align="right">&wgt.quotes.tooltip.today;:</cell>
                        <cell>
                            <f:concat>
                                <f:if>
                                    <f:value-of name="buy3"/>
                                    <f:concat>
                                        <f:format-number>
                                            <f:value-of name="buy3"/>
                                            <f:param name="precision">
                                                <f:value-of name="precision3"/>
                                            </f:param>
                                        </f:format-number>
                                        <f:value type="string"> (</f:value>
                                        <f:format-number>
                                            <f:value-of name="buy-change3"/>
                                            <f:param name="precision">
                                                <f:value-of name="precision3"/>
                                            </f:param>
                                            <f:param name="positive-sign">
                                                <f:value type="bool">true</f:value>
                                            </f:param>
                                        </f:format-number>
                                        <f:value type="string">)&#160;—&#160;</f:value>
                                    </f:concat>
                                    <f:value type="string"/>
                                </f:if>
                                <f:format-number>
                                    <f:value-of name="value3"/>
                                    <f:param name="precision">
                                        <f:value-of name="precision3"/>
                                    </f:param>
                                </f:format-number>
                                <f:value type="string"> (</f:value>
                                <f:format-number>
                                    <f:value-of name="change3"/>
                                    <f:param name="precision">
                                        <f:value-of name="precision3"/>
                                    </f:param>
                                    <f:param name="positive-sign">
                                        <f:value type="bool">true</f:value>
                                    </f:param>
                                </f:format-number>
                                <f:value type="string">)</f:value>
                            </f:concat>
                        </cell>
                    </row>
                    <f:optional>
                        <f:value-of name="tomorrow-node3"/>
                        <row>
                            <cell h-align="right">&wgt.quotes.tooltip.tomorrow;:</cell>
                            <cell>
                                <f:concat>
                                    <f:if>
                                        <f:value-of name="tomorrow-buy3"/>
                                        <f:concat>
                                            <f:format-number>
                                                <f:value-of name="tomorrow-buy3"/>
                                                <f:param name="precision">
                                                    <f:value-of name="precision3"/>
                                                </f:param>
                                            </f:format-number>
                                            <f:value type="string"> (</f:value>
                                            <f:format-number>
                                                <f:value-of name="tomorrow-buy-change3"/>
                                                <f:param name="precision">
                                                    <f:value-of name="precision3"/>
                                                </f:param>
                                                <f:param name="positive-sign">
                                                    <f:value type="bool">true</f:value>
                                                </f:param>
                                            </f:format-number>
                                            <f:value type="string">)&#160;—&#160;</f:value>
                                        </f:concat>
                                        <f:value type="string"/>
                                    </f:if>
                                    <f:format-number>
                                        <f:value-of name="tomorrow3"/>
                                        <f:param name="precision">
                                            <f:value-of name="precision3"/>
                                        </f:param>
                                    </f:format-number>
                                    <f:value type="string"> (</f:value>
                                    <f:format-number>
                                        <f:value-of name="tomorrow-change3"/>
                                        <f:param name="precision">
                                            <f:value-of name="precision3"/>
                                        </f:param>
                                        <f:param name="positive-sign">
                                            <f:value type="bool">true</f:value>
                                        </f:param>
                                    </f:format-number>
                                    <f:value type="string">)</f:value>
                                </f:concat>
                            </cell>
                        </row>
                    </f:optional>
                </grid>
            </tooltip>
            <action>
                <f:navigate action="2120">
                    <f:xpath>
                        <f:concat>
                            <f:value type="string">string(//quote[@id='</f:value>
                            <f:value-of name="id3"/>
                            <f:value type="string">']/url)</f:value>
                        </f:concat>
                        <f:value-of name="quote-list"/>
                    </f:xpath>
                </f:navigate>
            </action>
            <menu>
                <menuitem>
                    <text>&wgt.quotes.refresh;</text>
                    <action>
                        <f:assign name="update-id">
                            <f:update>
                                <f:value-of name="quotes-request"/>
                            </f:update>
                        </f:assign>
                        <f:assign name="throbber-end-time">
                            <f:add>
                                <f:timestamp/>
                                <f:value type="number">1.5</f:value>
                            </f:add>
                        </f:assign>
                    </action>
                </menuitem>
                <separator/>
                <f:optional>
                    <f:value-of name="has-data1"/>
                    <menuitem>
                        <text>
                            <f:concat>
                                <f:value type="string">&wgt.quotes.copy;&#160;</f:value>
                                <f:xpath>
                                    <f:concat>
                                        <f:value type="string">string(//quote[@id='</f:value>
                                        <f:value-of name="id1"/>
                                        <f:value type="string">']/name)</f:value>
                                    </f:concat>
                                    <f:value-of name="quote-list"/>
                                </f:xpath>
                            </f:concat>
                        </text>
                        <action>
                            <f:copy-to-clipboard>
                                <f:format-number>
                                    <f:if>
                                        <f:value-of name="displ-buy1"/>
                                        <f:value-of name="displ-buy1"/>
                                        <f:value-of name="displ-value1"/>
                                    </f:if>
                                    <f:param name="separate-groups">
                                        <f:value type="bool">false</f:value>
                                    </f:param>
                                </f:format-number>
                            </f:copy-to-clipboard>
                        </action>
                    </menuitem>
                </f:optional>
                <f:optional>
                    <f:value-of name="has-data2"/>
                    <menuitem>
                        <text>
                            <f:concat>
                                <f:value type="string">&wgt.quotes.copy;&#160;</f:value>
                                <f:xpath>
                                    <f:concat>
                                        <f:value type="string">string(//quote[@id='</f:value>
                                        <f:value-of name="id2"/>
                                        <f:value type="string">']/name)</f:value>
                                    </f:concat>
                                    <f:value-of name="quote-list"/>
                                </f:xpath>
                            </f:concat>
                        </text>
                        <action>
                            <f:copy-to-clipboard>
                                <f:format-number>
                                    <f:if>
                                        <f:value-of name="displ-buy2"/>
                                        <f:value-of name="displ-buy2"/>
                                        <f:value-of name="displ-value2"/>
                                    </f:if>
                                    <f:param name="separate-groups">
                                        <f:value type="bool">false</f:value>
                                    </f:param>
                                </f:format-number>
                            </f:copy-to-clipboard>
                        </action>
                    </menuitem>
                </f:optional>
                <menuitem>
                    <text>
                        <f:concat>
                            <f:value type="string">&wgt.quotes.copy;&#160;</f:value>
                            <f:xpath>
                                <f:concat>
                                    <f:value type="string">string(//quote[@id='</f:value>
                                    <f:value-of name="id3"/>
                                    <f:value type="string">']/name)</f:value>
                                </f:concat>
                                <f:value-of name="quote-list"/>
                            </f:xpath>
                        </f:concat>
                    </text>
                    <action>
                        <f:copy-to-clipboard>
                            <f:format-number>
                                <f:if>
                                    <f:value-of name="displ-buy3"/>
                                    <f:value-of name="displ-buy3"/>
                                    <f:value-of name="displ-value3"/>
                                </f:if>
                                <f:param name="separate-groups">
                                    <f:value type="bool">false</f:value>
                                </f:param>
                            </f:format-number>
                        </f:copy-to-clipboard>
                    </action>
                </menuitem>
                <separator/>
                <menuitem>
                    <text>&wgt.quotes.change;</text>
                    <action>
                        <f:setup-widget/>
                    </action>
                </menuitem>
                <menuitem>
                    <text>&wgt.quotes.delete;</text>
                    <action>
                        <f:remove-widget/>
                    </action>
                </menuitem>
                <menuitem>
                    <text>&wgt.quotes.add;</text>
                    <action>
                        <f:add-widget/>
                    </action>
                </menuitem>
            </menu>
        </button>
    </f:optional>
</widget>
